unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms,  Dialogs, ExtCtrls, Menus, ComCtrls,
  UProto, UFPuntuales;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Abrir1: TMenuItem;
    N1: TMenuItem;
    Cerrar1: TMenuItem;
    OpenDialog1: TOpenDialog;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    Puntuales1: TMenuItem;
    Negativo1: TMenuItem;
    procedure Abrir1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Negativo1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    M1,M2    : Mat3D;
    nx,ny    : integer;
    BM1      : TBitMap;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Este mtodo se ejecuta una sola vez al crear la aplicacin
procedure TForm1.FormCreate(Sender: TObject);
begin
  // creamos el BitMap de operacin
  BM1 := TBitMap.Create;
end;

// Abrir la imagen desde un archivo, con este modelo solo podemos abrir
// Archivos BMP de MS.
procedure TForm1.Abrir1Click(Sender: TObject);
var
  nom : string;
begin
  if OpenDialog1.Execute then begin
    nom := OpenDialog1.FileName;

    BM1.LoadFromFile(nom);  // lo carga a un BitMap en Memoria

    Image1.Picture.Assign(BM1);   // manda el BitMap al Image1 en la interfase

    nx := Image1.Width;
    ny := Image1.Height;
    M1.nc := nx;
    M1.nr := ny;

    BM2Mat(BM1,M1);  // copia el BitMap a la matriz M1[x][y][c]

  end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject;
   Shift: TShiftState;
   X, Y: Integer);
var
  Pix   : integer;
  r,g,b : byte;
begin
   Pix := Image1.Canvas.Pixels[X,Y];
   r := Pix and $FF;
   g := (Pix SHR 8 ) and $FF;
   b := (Pix SHR 16) and $FF;

   // escribir componentes
   StatusBar1.Panels[0].Text := IntToStr(X);
   StatusBar1.Panels[1].Text := IntToStr(Y);

   StatusBar1.Panels[2].Text := IntToStr(r);
   StatusBar1.Panels[3].Text := IntToStr(g);
   StatusBar1.Panels[4].Text := IntToStr(b);

end;

// Negativo
procedure TForm1.Negativo1Click(Sender: TObject);
begin
  if (M1.nc+M1.nr = 0) then ShowMessage('No ha abierto an alguna Imagen...');
  
  FP_Negativo(M1,M2);
  Mat2BM(M2,BM1);
  Image1.Picture.Assign(BM1);
end;

end.
